local addonName, PRIVATE = ...
local MBFunc = PRIVATE.Functions
MessageBoardXML.Editor.ID=nil;
MessageBoardXML.Editor.Goal=nil;
MessageBoardXML.Editor.Level=nil;
MessageBoardXML.Editor.Category=nil;
MessageBoardXML.Editor.CopyText=nil;
local Quotedmsg=nil;
local L = LibStub("AceLocale-3.0"):GetLocale("MessageBoard")
local MBDialog = LibStub("LibDialog-1.0")
local ren=DuckLibMB.Render;

function MessageBoard_Editor_OnLoad(self)
	tinsert(UISpecialFrames,self);
end

function MessageBoardXML.Editor:Init(id,category,topic,msg,level)
	self.msg=msg;
	local message=msg.Text;
	self.Goal=msg.Time;
	Quotedmsg=message;
	self.Category=category;
	self.ID=id;
	if (not level) then level=0; end
	self.Level=level;
	if (not topic) then MessageBoard_EditorTopicLabel:Hide(); MessageBoard_EditorTopicName:Hide(); MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide(); MessageBoard_Editor_Quote:Hide();
	else
		local catname
		catname=MessageBoardXML:Setting("Category"..category.."Value");
		MessageBoard_EditorTopicLabel:Show(); MessageBoard_EditorTopicName:Show();MessageBoard_EditorCategoryName:SetText(catname);
		MessageBoard_EditorTopicName:SetText(ren:toASCII(topic));MessageBoard_EditorTopicName:SetFocus();MessageBoard_EditorTopicError:SetText("");
		MessageBoard_EditorSaveDraft:Show();MessageBoard_EditorLoadDraft:Show();
		if (MessageBoardXML.Administrator) then  -- only allow admins to set stickies,announcements,and locked posts
		MessageBoard_Editor_Announce:Show(); MessageBoard_Editor_Sticky:Show(); MessageBoard_Editor_Locked:Show();
		else MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide();	end
	end

	if MessageBoard_LS.Quoted==true then MessageBoard_Editor_Quote:SetChecked(true); end
	if id==3 and MessageBoard_LS.Quoted==false then MessageBoard_Editor_Quote:SetChecked(false); message="" ;end -- only if replying

	if (not message) then message=""; end

	MessageBoard_EditorSBEdit:SetText(ren:toASCII(message));
	MessageBoard_Editor_Announce:SetChecked(false);
	MessageBoard_Editor_Sticky:SetChecked(false);
	MessageBoard_Editor_Locked:SetChecked(false);
	MessageBoard_EditorCategoryLabel:SetText(L["EDITOR_CAT_LABEL"])
	MessageBoard_EditorTopicLabel:SetText(L["EDITOR_TOPIC_LABEL"])
	MessageBoard_EditorMessageLabel:SetText(L["EDITOR_MESSAGE_LABEL"])
	MessageBoard_EditorSave:SetText(L["EDITOR_MESSAGE_SAVE"])
	MessageBoard_EditorSaveDraft:SetText(L["EDITOR_MESSAGE_SAVEDRAFT"])
	MessageBoard_EditorLoadDraft:SetText(L["EDITOR_MESSAGE_LOADDRAFT"])
	MessageBoard_EditorCopyAll:SetText(L["EDITOR_MESSAGE_COPY"])
	MessageBoard_EditorDiscard:SetText(L["EDITOR_MESSAGE_DISCARD"])
	MessageBoard_Editor_AnnounceText:SetText(L["EDITOR_MESSAGE_ANNOUNCE"])
	MessageBoard_Editor_StickyText:SetText(L["EDITOR_MESSAGE_STICKY"])
	MessageBoard_Editor_LockedText:SetText(L["EDITOR_MESSAGE_LOCKED"])
	MessageBoard_Editor_QuoteText:SetText(L["EDITOR_MESSAGE_QUOTE"])
	MessageBoard_PollEditorPollQLabel:SetText(L["EDITOR_POLL_QUESTION"])
	MessageBoard_PollEditorPollALabel:SetText(L["EDITOR_POLL_ANSWERS"])
	local i
	for i=1,12 do
		_G["MessageBoard_PollAnswersScrollerAnswer"..i.."Title"]:SetText(L["EDITOR_POLL_ANSWER"]..i..":")
	end
	if (self.Level==30) then MessageBoard_Editor_Locked:SetChecked(true);
	elseif (self.Level==20) then MessageBoard_Editor_Announce:SetChecked(true);
	elseif (self.Level==10) then MessageBoard_Editor_Sticky:SetChecked(true);
	end
	MessageBoard_EditorSBEdit:SetCursorPosition(0);
	MessageBoard_EditorTopicName:SetCursorPosition(0);

	if self.ID==MessageBoardXML.Editor.ID_NEWPOLL then
		MessageBoard_Editor:Show();	MessageBoard_PollEditor:Show();
		--MessageBoard_EditorSaveDraft:Hide();MessageBoard_EditorLoadDraft:Hide();
	elseif self.ID==MessageBoardXML.Editor.ID_EDITMESSAGE then
		MessageBoard_Editor:Show();	MessageBoard_PollEditor:Hide();
	    if self.msg.Poll then
			 MessageBoard_EditorTopicName:Hide(); MessageBoard_Editor_Announce:Hide(); MessageBoard_Editor_Sticky:Hide(); MessageBoard_Editor_Locked:Hide(); MessageBoard_Editor_Quote:Hide();
		end
	else MessageBoard_Editor:Show(); MessageBoard_PollEditor:Hide();
	end
end

function MessageBoardXML.Editor:CheckClick(self)
	if (self==MessageBoard_Editor_Announce) then
		MessageBoard_Editor_Sticky:SetChecked(false);
		MessageBoard_Editor_Locked:SetChecked(false);
	end
	if (self==MessageBoard_Editor_Sticky) then
		MessageBoard_Editor_Announce:SetChecked(false);
		MessageBoard_Editor_Locked:SetChecked(false);
	end
	if (self==MessageBoard_Editor_Locked) then
		MessageBoard_Editor_Announce:SetChecked(false);
		MessageBoard_Editor_Sticky:SetChecked(false);
	end
	if MessageBoardXML.Editor.ID==3 then
		if (MessageBoard_Editor_Quote:GetChecked()) then
			local mycurrenttext=nil;
			local newmsg=nil;
			mycurrenttext=MessageBoard_EditorSBEdit:GetText();
			newmsg=ren:toASCII(mycurrenttext..Quotedmsg);
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);
		else
			local mycurrenttext=nil;
			local newmsg="";
			MessageBoard_EditorSBEdit:SetText(newmsg); MessageBoard_EditorSBEdit:SetCursorPosition(0);
		end
	end
end

function MessageBoardXML.Editor:GetItemLink(itemID)
	if (not itemID) then return nil; end
	local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,itemTexture=GetItemInfo(itemID);
	return itemLink;
end

function MessageBoardXML.Editor:ItemDrop(editor)
	local item,itemID,link=GetCursorInfo();
	ClearCursor();
	if (not link) then return; end
	if (editor) then
		MessageBoard_EditorSBEdit:Insert(self:GetItemLink(link));
		return;
	end
end

function MessageBoardXML.Editor:CopyAll()
	MessageBoardXML.Editor.CopyText=MessageBoard_EditorSBEdit:GetText();
	MBDialog:Register("MessageBoardTextEditorCopyDialog", {
	  text = L["POPUP_TEXT_COPY"],
	  buttons = {
		{
		  text = "Close",
		},
	  },
	  editboxes = {
		{
		  auto_focus = true,
		  width=200,
		},
	  },
	  on_show = function(self, data)
		self.text:SetFormattedText("\n"..L["POPUP_TEXT_COPY"].."\n")
		self.editboxes[1]:SetText(MessageBoardXML.Editor.CopyText)
		self.editboxes[1]:HighlightText()
	  end,
	  hide_on_escape = true,
	  show_while_dead = true,
	})
	MBDialog:Spawn("MessageBoardTextEditorCopyDialog")
end

function MessageBoardXML.Editor:SaveDraft()
	MessageBoard_LS.Draft = MessageBoard_EditorSBEdit:GetText();
	MessageBoard_LS.DraftTitle = MessageBoard_EditorTopicName:GetText()
	MessageBoard_EditorTopicError:SetText("|cFFFFFFFF"..L["EDITOR_DRAFT_SAVED"]);
end

function MessageBoardXML.Editor:LoadDraft()
	if MessageBoard_LS.Draft then
		MessageBoard_EditorSBEdit:SetText(MessageBoard_LS.Draft);
		MessageBoard_EditorTopicName:SetText(MessageBoard_LS.DraftTitle);
		MessageBoard_EditorTopicError:SetText("|cFFFFFFFF"..L["EDITOR_DRAFT_LOADED"]);
	end
end


function MessageBoardXML.Editor:Save()
	local base,_,_,_=MessageBoardXML:ValidateBoardDB();
	local topic=ren:toHTML(MessageBoard_EditorTopicName:GetText());

	if (MessageBoard_Editor_Locked:GetChecked()) then self.Level=30;
	elseif (MessageBoard_Editor_Announce:GetChecked()) then self.Level=20;
	elseif (MessageBoard_Editor_Sticky:GetChecked()) then self.Level=10;
	elseif (self.ID==MessageBoardXML.Editor.ID_NEWPOLL) then self.Level=40;
	elseif (self.Level==40) then self.Level=40;
	else self.Level=0; end

	if (type(self.ID)=="function") then
		self.ID(self,self.Category,topic,ren:toHTML(MessageBoard_EditorSBEdit:GetText()),self.Goal,self.Level);	-- ED
	else
		if self.ID==MessageBoardXML.Editor.ID_NEWTOPIC then -- new topic
			self.msg.Poll=nil;
			if (not topic or MBFunc.isBlank(topic)) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_NAME"]); return; end
			if (base[self.Category][topic]) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_TOPIC_EXISTS"]); return; end
			if (self.ID==MessageBoardXML.Editor.ID_NEWTOPIC and base[self.Category][topic]) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_TOPIC_EXISTS"]); return; end
		elseif self.ID==MessageBoardXML.Editor.ID_NEWMESSAGE then -- new message/reply
			self.msg.Poll=nil;			
		elseif self.ID==MessageBoardXML.Editor.ID_NEWPOLL then -- new poll
			local index;
			self.msg.Poll={};
			for index=1,12 do local txt=strtrim(_G["MessageBoard_PollAnswersScrollerAnswer"..index]:GetText()) or ""; if (txt~="") then table.insert(self.msg.Poll,ren:toHTML((txt))); end end	-- ED
			self.msg.Poll.Question=ren:toHTML((strtrim(tostring(MessageBoard_PollEditorPollName:GetText()))) or "");	-- ED
			if (MBFunc.isBlank(self.msg.Poll.Question)) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_POLLQ"]); return; end
			if (MBFunc.isBlank(self.msg.Poll[1])) then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_POLLA"]); return; end
			if MBFunc.isBlank(topic or "") then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_MISSING_NAME"]); return; end
			if base[self.Category][topic] then MessageBoard_EditorTopicError:SetText("|cFFFF0000"..L["EDITOR_TOPIC_EXISTS"]); return; end	
		elseif self.ID==MessageBoardXML.Editor.ID_EDITMESSAGE then -- edited text
			if self.msg.Poll then self.Level=40; end			
		end
		self.msg.Text=ren:toHTML(MessageBoard_EditorSBEdit:GetText());
		MessageBoardXML:EditedText(self.ID,self.Category,topic,self.msg,self.Level);
	end
	MessageBoard_Editor:Hide();
	MessageBoardXML:ViewTopics();
end

function MessageBoardXML.Editor:Discard()
	MessageBoard_Editor:Hide();
	MessageBoardXML:ViewTopics()
end

function MessageBoardXML.Editor:ResetPoll()
	MessageBoard_PollEditorPollName:SetText("");
	local i=1;
	for i=1,12 do
	_G["MessageBoard_PollAnswersScrollerAnswer"..i]:SetText("");
	end
end

function MessageBoard_Editor_OnCursorChanged(self, x, y, width, height)
	local s_height = MessageBoard_EditorSB:GetHeight()
	local s_top    = MessageBoard_EditorSB:GetVerticalScroll()
	local s_bottom = s_top + s_height
	local cursor_y = -y
	local fudge = 11 -- allows for line height, padding and a little extra
	if cursor_y < s_top then
		MessageBoard_EditorSB:SetVerticalScroll(cursor_y)
	elseif cursor_y + fudge > s_bottom then
		MessageBoard_EditorSB:SetVerticalScroll(cursor_y + fudge - s_height)
	end
end

-- Hook the container buttons
local containerFunc = function(button)
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(GetContainerItemLink(button:GetParent():GetID(), button:GetID()))
		end
	end
end
hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", containerFunc)

local bankFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetContainerItemLink(BANK_CONTAINER, id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("BankFrameItemButtonGeneric_OnModifiedClick", bankFunc)

local inboxFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetInboxItemLink(InboxFrame.openMailID, id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("InboxFrame_OnModifiedClick", inboxFunc)

local dollFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetInventoryItemLink("player", id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("PaperDollItemSlotButton_OnModifiedClick", dollFunc)

local merchantFunc = function(...)
	local args = {...}
	local self = args[1]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			local id = self:GetID()
			local link = GetMerchantItemLink(id)
			MessageBoard_EditorSBEdit:Insert(link)
		end
	end
end
hooksecurefunc("MerchantItemButton_OnModifiedClick", merchantFunc)

local linkFunc = function(...)
	local args = {...}
	local self = args[1]
	local linktext = args[3]
	if IsShiftKeyDown() then
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(linktext)
		end
	end
end
hooksecurefunc("ChatFrame_OnHyperlinkShow", linkFunc)

local spellFunc = function(self, button)
	if IsShiftKeyDown() then
		local offset
		local page
		if SpellBookFrame.bookType == BOOKTYPE_PET then
			offset = 0
			page = SPELLBOOK_PAGENUMBERS[BOOKTYPE_PET]
		else
			offset = SpellBookFrame.selectedSkillLineOffset
			page = SPELLBOOK_PAGENUMBERS[SpellBookFrame.selectedSkillLine]
		end
		local sid = self:GetID() + offset + (SPELLS_PER_PAGE*(page - 1))
		if MessageBoard_EditorSBEdit:HasFocus() then
			MessageBoard_EditorSBEdit:Insert(GetSpellLink(sid, SpellBookFrame.bookType))
		end
	end
end
hooksecurefunc("SpellButton_OnModifiedClick", spellFunc)